/*
*	New C++ File starts here.
*	This file should be named fuzzyn.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "fuzzyn.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : fuzzyFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
int fuzzyFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case FUZZY_HALT_TYPE:
		((FUZZY_HALT *) buffer)->update(cms);
		break;
	case FUZZY_INIT_TYPE:
		((FUZZY_INIT *) buffer)->update(cms);
		break;
	case FUZZY_RUN_TYPE:
		((FUZZY_RUN *) buffer)->update(cms);
		break;
	case FUZZY_SET_DEFUZZ_TYPE:
		((FUZZY_SET_DEFUZZ *) buffer)->update(cms);
		break;
	case FUZZY_SET_INPUT_GAINS_TYPE:
		((FUZZY_SET_INPUT_GAINS *) buffer)->update(cms);
		break;
	case FUZZY_SET_IN_MF_TYPE:
		((FUZZY_SET_IN_MF *) buffer)->update(cms);
		break;
	case FUZZY_SET_IN_UD_TYPE:
		((FUZZY_SET_IN_UD *) buffer)->update(cms);
		break;
	case FUZZY_SET_OUTPUT_GAINS_TYPE:
		((FUZZY_SET_OUTPUT_GAINS *) buffer)->update(cms);
		break;
	case FUZZY_SET_OUT_MF_TYPE:
		((FUZZY_SET_OUT_MF *) buffer)->update(cms);
		break;
	case FUZZY_SET_OUT_UD_TYPE:
		((FUZZY_SET_OUT_UD *) buffer)->update(cms);
		break;
	case FUZZY_SET_PREMISE_TYPE:
		((FUZZY_SET_PREMISE *) buffer)->update(cms);
		break;
	case FUZZY_STATUS_TYPE:
		((FUZZY_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *fuzzy_symbol_lookup(int type)
{
	switch(type)
	{
	case FUZZY_HALT_TYPE:
		return "FUZZY_HALT";
	case FUZZY_INIT_TYPE:
		return "FUZZY_INIT";
	case FUZZY_RUN_TYPE:
		return "FUZZY_RUN";
	case FUZZY_SET_DEFUZZ_TYPE:
		return "FUZZY_SET_DEFUZZ";
	case FUZZY_SET_INPUT_GAINS_TYPE:
		return "FUZZY_SET_INPUT_GAINS";
	case FUZZY_SET_IN_MF_TYPE:
		return "FUZZY_SET_IN_MF";
	case FUZZY_SET_IN_UD_TYPE:
		return "FUZZY_SET_IN_UD";
	case FUZZY_SET_OUTPUT_GAINS_TYPE:
		return "FUZZY_SET_OUTPUT_GAINS";
	case FUZZY_SET_OUT_MF_TYPE:
		return "FUZZY_SET_OUT_MF";
	case FUZZY_SET_OUT_UD_TYPE:
		return "FUZZY_SET_OUT_UD";
	case FUZZY_SET_PREMISE_TYPE:
		return "FUZZY_SET_PREMISE";
	case FUZZY_STATUS_TYPE:
		return "FUZZY_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for FUZZY_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_RUN::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for FUZZY_SET_INPUT_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_INPUT_GAINS::update(CMS *cms)
{
	cms->update(input_gains,2);

}


/*
*	NML/CMS Update function for FUZZY_SET_IN_MF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_IN_MF::update(CMS *cms)
{
	cms->update(num_of_current_in_ud);
	cms->update(num_of_current_in_mf);
	cms->update(mf_type);
	cms->update(mf_center);
	cms->update(mf_spread);

}


/*
*	NML/CMS Update function for FUZZY_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_HALT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for FUZZY_SET_IN_UD
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_IN_UD::update(CMS *cms)
{
	cms->update(num_of_current_in_ud);
	cms->update(gain);
	cms->update(first_center);
	cms->update(last_center);
	cms->update(mf_type);
	cms->update(spread);

}


/*
*	NML/CMS Update function for FUZZY_SET_OUT_UD
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_OUT_UD::update(CMS *cms)
{
	cms->update(num_of_current_out_ud);
	cms->update(gain);
	cms->update(first_center);
	cms->update(last_center);
	cms->update(mf_type);
	cms->update(spread);

}


/*
*	NML/CMS Update function for FUZZY_SET_DEFUZZ
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_DEFUZZ::update(CMS *cms)
{
	cms->update(defuzz_type);

}


/*
*	NML/CMS Update function for FUZZY_SET_OUT_MF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_OUT_MF::update(CMS *cms)
{
	cms->update(num_of_current_out_ud);
	cms->update(num_of_current_out_mf);
	cms->update(mf_type);
	cms->update(mf_center);
	cms->update(mf_spread);

}


/*
*	NML/CMS Update function for FUZZY_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_INIT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for FUZZY_SET_OUTPUT_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_OUTPUT_GAINS::update(CMS *cms)
{
	cms->update(output_gains,2);

}


/*
*	NML/CMS Update function for FUZZY_SET_PREMISE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_SET_PREMISE::update(CMS *cms)
{
	cms->update(premise_type);

}


/*
*	NML/CMS Update function for FUZZY_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
void FUZZY_STATUS::update(CMS *cms)
{
	cms->update(inputs_to_fuzzy,2);
	cms->update(outputs_of_fuzzy,2);
	cms->update(defuzz_type);
	cms->update(premise_type);
	cms->update(num_of_current_in_ud);
	cms->update(gain_for_in_ud);
	cms->update(num_of_current_in_mf);
	cms->update(type_of_current_in_mf);
	cms->update(center_of_current_in_mf);
	cms->update(spread_of_current_in_mf);
	cms->update(num_of_current_out_ud);
	cms->update(gain_for_out_ud);
	cms->update(num_of_current_out_mf);
	cms->update(type_of_current_out_mf);
	cms->update(center_of_current_out_mf);
	cms->update(spread_of_current_out_mf);

}

/*
*	Constructor for FUZZY_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_RUN::FUZZY_RUN()
	: RCS_CMD_MSG(FUZZY_RUN_TYPE,sizeof(FUZZY_RUN))
{

}

/*
*	Constructor for FUZZY_SET_INPUT_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_INPUT_GAINS::FUZZY_SET_INPUT_GAINS()
	: RCS_CMD_MSG(FUZZY_SET_INPUT_GAINS_TYPE,sizeof(FUZZY_SET_INPUT_GAINS))
{
	/*
	* The array input_gains should be initialized here.
	*/


}

/*
*	Constructor for FUZZY_SET_IN_MF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_IN_MF::FUZZY_SET_IN_MF()
	: RCS_CMD_MSG(FUZZY_SET_IN_MF_TYPE,sizeof(FUZZY_SET_IN_MF))
{
	num_of_current_in_ud = (int) 0;
	num_of_current_in_mf = (int) 0;
	mf_type = (int) 0;
	mf_center = (double) 0;
	mf_spread = (double) 0;

}

/*
*	Constructor for FUZZY_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_HALT::FUZZY_HALT()
	: RCS_CMD_MSG(FUZZY_HALT_TYPE,sizeof(FUZZY_HALT))
{

}

/*
*	Constructor for FUZZY_SET_IN_UD
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_IN_UD::FUZZY_SET_IN_UD()
	: RCS_CMD_MSG(FUZZY_SET_IN_UD_TYPE,sizeof(FUZZY_SET_IN_UD))
{
	num_of_current_in_ud = (int) 0;
	gain = (double) 0;
	first_center = (double) 0;
	last_center = (double) 0;
	mf_type = (int) 0;
	spread = (double) 0;

}

/*
*	Constructor for FUZZY_SET_OUT_UD
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_OUT_UD::FUZZY_SET_OUT_UD()
	: RCS_CMD_MSG(FUZZY_SET_OUT_UD_TYPE,sizeof(FUZZY_SET_OUT_UD))
{
	num_of_current_out_ud = (int) 0;
	gain = (double) 0;
	first_center = (double) 0;
	last_center = (double) 0;
	mf_type = (int) 0;
	spread = (double) 0;

}

/*
*	Constructor for FUZZY_SET_DEFUZZ
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_DEFUZZ::FUZZY_SET_DEFUZZ()
	: RCS_CMD_MSG(FUZZY_SET_DEFUZZ_TYPE,sizeof(FUZZY_SET_DEFUZZ))
{
	defuzz_type = (int) 0;

}

/*
*	Constructor for FUZZY_SET_OUT_MF
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_OUT_MF::FUZZY_SET_OUT_MF()
	: RCS_CMD_MSG(FUZZY_SET_OUT_MF_TYPE,sizeof(FUZZY_SET_OUT_MF))
{
	num_of_current_out_ud = (int) 0;
	num_of_current_out_mf = (int) 0;
	mf_type = (int) 0;
	mf_center = (double) 0;
	mf_spread = (double) 0;

}

/*
*	Constructor for FUZZY_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_INIT::FUZZY_INIT()
	: RCS_CMD_MSG(FUZZY_INIT_TYPE,sizeof(FUZZY_INIT))
{

}

/*
*	Constructor for FUZZY_SET_OUTPUT_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_OUTPUT_GAINS::FUZZY_SET_OUTPUT_GAINS()
	: RCS_CMD_MSG(FUZZY_SET_OUTPUT_GAINS_TYPE,sizeof(FUZZY_SET_OUTPUT_GAINS))
{
	/*
	* The array output_gains should be initialized here.
	*/


}

/*
*	Constructor for FUZZY_SET_PREMISE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_SET_PREMISE::FUZZY_SET_PREMISE()
	: RCS_CMD_MSG(FUZZY_SET_PREMISE_TYPE,sizeof(FUZZY_SET_PREMISE))
{
	premise_type = (int) 0;

}

/*
*	Constructor for FUZZY_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Tue Oct 05 10:40:06 EDT 1999
*/
FUZZY_STATUS::FUZZY_STATUS()
	: RCS_STAT_MSG(FUZZY_STATUS_TYPE,sizeof(FUZZY_STATUS))
{
	/*
	* The array inputs_to_fuzzy should be initialized here.
	*/

	/*
	* The array outputs_of_fuzzy should be initialized here.
	*/

	defuzz_type = (int) 0;
	premise_type = (int) 0;
	num_of_current_in_ud = (int) 0;
	gain_for_in_ud = (double) 0;
	num_of_current_in_mf = (int) 0;
	type_of_current_in_mf = (int) 0;
	center_of_current_in_mf = (double) 0;
	spread_of_current_in_mf = (double) 0;
	num_of_current_out_ud = (int) 0;
	gain_for_out_ud = (double) 0;
	num_of_current_out_mf = (int) 0;
	type_of_current_out_mf = (int) 0;
	center_of_current_out_mf = (double) 0;
	spread_of_current_out_mf = (double) 0;

}

